=========
Structure
=========

.. contents:: :local:

Definitions
===========
* APP: Firmware application layer
	| - Contains the main firmware level.
* FWO: Firmware object layer
	| - StateMachine(s), Time-based operation(s) are handled in this level.
* HWO: Hardware object layer
	| - Each module represents a hardware corresponding part.
* HAL: Hardware abstraction layer
	| - Each module represents a microcontroller sorresponding part (like ADC, ...).
	| - Code above this level is independent from underlaying microcontroller.

Layering/Modules
================

.. image:: ../pictures/Firmware_structure.svg
  :width: 750
  :alt: Firmware modules and layers

The picture above shows the main relevant firmware modules, that are used in the datalogger unit at all.
Some of them are generated automaticaly with the `STM32CubeMX`_, which is part of the `STM32CubeIDE`_ environment. But most of this
automatic generated modules are extended by some parts in the corresponding user-code sections.

Main Hierarchy
--------------

- STM32L496RGTX_FLASH.ld
	- Linker File, which defines the address-space of the usable memory.
- \*.launch
	- Debug configuration settings for different build (debug/release) or execution processes.
- \*.ioc
	- Contains the STM32CubeMX-Configuration, for the basic system setup for the microcontroller.

.. image:: ../pictures/firmwareLayer/Datalogger_FirmwareLayer_Hierarchy.JPG
  :width: 350
  :alt: Firmware main hierarchy
  
Core Files
----------

All these files are generated by the `STM32CubeMX`_-Application. They define mainly the initialization configuration and calls of `Drivers`_ functions to
do the corresponding setups of the underlaying peripherals. Some of the header and source files are extended in user-code sections to extend there functionalities
needed for the application.

- Inc
	- The header files
- Src
	- The source files
	- **Main.c**-file is located here
- Startup
	- Assembler Code, where all parts of the bootstrap-loader are integratet.

.. image:: ../pictures/firmwareLayer/Datalogger_FirmwareLayer_Core.JPG
  :width: 150
  :alt: Firmware core files
  
General Definitions (DEF)
-------------------------

This file contains general project specific types/defines and were added by the developer. So overal used data-types/data-structures (fwVersion_t, dataForBootloader_t) 
and defines (Bootloading-Tags) are defined in this file.

.. image:: ../pictures/firmwareLayer/Datalogger_FirmwareLayer_Definitions.JPG
  :width: 150
  :alt: Firmware general definitions/datatypes

Drivers
-------

All these files are generated by the `STM32CubeMX`_-Application. They are based on the corresponding STM32L4xx_HAL_Driver library, which 
contains an API for all used peripherals of the microcontroller.

- CMSIS
	- Common Microcontroller Software Interface Standard: This is a vendor-independent abstraction lyer for all ARM Cortex based microcontrollers. 
- STM32L4xx_HAL_Driver
	- Driver Library for the hardware abstractio layer.

.. image:: ../pictures/firmwareLayer/Datalogger_FirmwareLayer_Drivers.JPG
  :width: 150
  :alt: Firmware CMSIS/STM32L4xx_HAL-Drivers

FAT-Filesystem (FATFS)
----------------------

Gives a general abstraction, functions names are independent from the underlaying used Hardware (like SD-Card, `USB_HOST`_). The connection to the underlaying 
hardware is connected inside the source files.

- APP
	- Contains the initialization/deinitialization functions used together with the `USB_HOST`_ Interface.
- Target
	- Contains the FAT-Filesystem configuration
	- Contains the `USB_HOST`_ function calles internally and the generic header with standard disk_initialize, disk_status, disk_read, disk_write & disk_ioctrl functions.

.. image:: ../pictures/firmwareLayer/Datalogger_FirmwareLayer_FAT_Filesystem.JPG
  :width: 150
  :alt: Firmware FAT-Filesystem

Firmware object layer (FWO)
-------------------------------

Project based firmware object source and header file, grouped/named as modules. They call functions of the `Hardware abstraction layer (HAL)`_.

- COMM
	- Setup of the `USB_DEVICE`_ operating as CDC interface.
	- | Parse of the received byte located in the `USB_DEVICE`_ buffer, to check if a new correct protocol message was received.
	  | If a command is executed, in the internally callback function, the corresponding action is performed automaticaly.
	- dataStream function, to be able to stream measurement data out
- datalogger
	- A very high abstraction of the possible functionalities of the complete datalogger itself.
- dataManager
	- Contains all the needed functionality to handle all the different data's of the datalogger unit (located in `FLASH (AT25SF321B)`_).
	- Internally the `FLASH (AT25SF321B)`_ is accessed to read/write the different data/configuration to the on PCB `FLASH (AT25SF321B)`_-IC.
- HMI
	- Simplify the optical LED handling by corresponding function support. This includes the possible LED color and pattern options.
	- Internally the function _hmi_ledTick() handle the current shown up led value. This function is called by SysTick.
- stringConverter
	- User implemented function, to simplify and speed-up the floating-point to a defined string conversion.

.. image:: ../pictures/firmwareLayer/Datalogger_FirmwareLayer_FWO.JPG
  :width: 150
  :alt: Firmware object layer modules/files
  
Hardware abstraction layer (HAL)
--------------------------------

Extended hardware abstration module. Builds together with the `Drivers`_ the complete hardware abstraction layer. But these file(s) are user implementation, instead of 
the generated ones from the `Drivers`_ folder.

- HAL_DWT
	- Additional module, to support the access to the "Debug and Trace-Unit" of the CortexM Microcontroller. Usefull for debugging (count the number of clock cycles over a given range).

.. image:: ../pictures/firmwareLayer/Datalogger_FirmwareLayer_HAL.JPG
  :width: 150
  :alt: Hardware abstraction layer modules/files
  
Hardware object layer (HWO)
---------------------------

Abstraction layer of all Hardware objects, which correspond to a physical hardware component on the datalogger PCB.

- A_IN
	- setup of the ADC Peripheral by calling `Drivers`_ functions.
	- sampleAndGet-functions for
		- VBattery
		- V_USB_CC Lines
		- PA3_ADC_IN8, PA4_ADC_IN9, PA5_ADC_IN10, PA6_ADC_IN11
- BME280
	- setup function for the `BME280`_ sensor with the requested configuration parameters (oversampling, filter)
	- get the measurment and conversion time by corresponding function-call
	- dataGet-function, to readout the sampled values of the `BME280`_ sensor
- DIG_IO
	- setup function to configure all simple digital in-/ouputs
	- getter-functions for onBoard data logger inputs (user-Button1, user-Button2, usbDetection, sdCardDetection)
	- setter-functions for onBoard data logger outputs (supplyMeasPath, otgDeviceMode, 5VtoUSBSwitch, 5VExtPwr, 3V3Pwr, 17VPwr)
	- complete API for external available data logger in/outputs (currently unused, but available for extensions)
		- digIO_setup
		- digIO_cbRegister
		- digIO_read
		- digIO_write
- FLASH
	- setup function to configure the `FLASH (AT25SF321B)`_ IC.
	- function to read a defined number of bytes by a defined address from `FLASH (AT25SF321B)`_ IC 
	- function to write a defined number of bytes by a defined address to `FLASH (AT25SF321B)`_ IC
	- different erase-functions (4kByte-Blocks or complete chip)
- MMC
	- Standard MMC/SDC interface (unused in this project) to interact with the SD-Card
- RG_LED
	- setup function for Red/Green LED, which can be connected over external 3-pin connector
	- lumnosity-set funtion
	- color-set function
- SYS
	- setup function for minimal system functionality (digIO-Init, Clock-Tree-Setup)
	- system managment functions (sleep, standby, reset, bootloaderEnter)
	- sysTick module handling
	- sysWakeup handling (wakeUp from Standby)
	- RTC handling (DateTime-Set/Get, BackupRegisters)

.. image:: ../pictures/firmwareLayer/Datalogger_FirmwareLayer_HWO.JPG
  :width: 150
  :alt: Hardware object layer modules/files
  
Middlewares
-----------

All these files are generated by the `STM32CubeMX`_-Application. They contains mainly the library-files for `USB_DEVICE`_, `USB_HOST`_ and the FAT-Filesystem. 
Some of the header and source files are extended in user-code sections to extend there functionalities
needed by the application.

- ST
	- STM32_USB_Device_Library
		- CDC (communication device class) Class support and configuration
		- USB Core support for USB-DEVICE
	- STM32_USB_Host_Library
		- MSC (mass storage class) Class support and configuration
		- USB Core support for USB-HOST
- Third_Party
	- FatFs
		- generic/common FAT-Filesystem implementation

.. image:: ../pictures/firmwareLayer/Datalogger_FirmwareLayer_Middlewares.JPG
  :width: 150
  :alt: Firmware Middlewares libraries
  
TestPrograms
------------

Multiple test programs, which could be activated (commented out) in the main.c file. All of them are used together with the 
datalogger hardware to be able to run different kind of tests. Some are used to test only specific hardware components, so they
interact only with HWO-Layer and lower-Layers. Others are higher level test functions for FWO-Layer (but also togheter will all lower-layers).

.. image:: ../pictures/firmwareLayer/Datalogger_FirmwareLayer_Testprograms.JPG
  :width: 150
  :alt: Firmware TestPrograms files
  
USB_DEVICE
----------

All these files are generated by the `STM32CubeMX`_-Application.

- App
	- Extended because of some datalogger PCB-hardware specific needed interactions
	- Function will be called from user application. Internally they calling functions of the USB-Device Library (`Middlewares`_)
- Target
	- USB-Device configuration (endpoints, number of interfaces, description)

.. image:: ../pictures/firmwareLayer/Datalogger_FirmwareLayer_USB_DEVICE.JPG
  :width: 150
  :alt: Firmware USB_DEVICE interface, description, class and configuration parts
  
USB_HOST
--------

All these files are generated by the `STM32CubeMX`_-Application.

- App
	- Function will be called from user application. Internally they calling functions of the USB-Host Library (`Middlewares`_)
- Target
	- USB-Device configuration (endpoints, number of interfaces, description)
	- Platform specific parts (datalogger PCB-hardware VBUS-Signal handling)
	
.. image:: ../pictures/firmwareLayer/Datalogger_FirmwareLayer_USB_HOST.JPG
  :width: 150
  :alt: Firmware USB_HOST interface, description, class and configuration parts
	
Naming conventions/Code Style
=============================

All user defined \*.h/\*.c-Files are coded with the same naming conventions.

Header-File
-----------

- contains only the needed includes for the header data-types itself
- contains public defines / data-Type definition that needs to be exported
- public functions are using the following code-Style: "Module"_"functionName"

Source-File
-----------

- contains all needed includes used by this source file itself
- contains private defines / data-Type definition that are only used internally of the module
- contains all variables of this module in private context (static)
- contains all private module functions (internally defined and with static)
	- private functions are using the following code-Style: _"Module"_"functionName"
- contains the implementation of the public and private function

Links
=====
.. _STM32CubeIDE: https://www.st.com/en/development-tools/stm32cubeide.html
.. _BME280: https://www.bosch-sensortec.com/products/environmental-sensors/humidity-sensors-bme280/
.. _FLASH (AT25SF321B): https://www.dialog-semiconductor.com/sites/default/files/2021-04/DS-AT25SF321B-179E-062020.pdf
.. _STM32CubeMX: https://hsr-iet.gitlab.io/wabesense/datalogger_firmware/debugEnvironment.html#stm32cubemx

.. target-notes::